#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <sys/un.h>
#include <net/if.h>

#include <assert.h>
#include <errno.h>
#include <getopt.h>
#include <sys/uio.h>

#include <asm/types.h>  //BPF ʼ 
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#include <sys/ioctl.h>	//For IO Option 

#include <syslog.h>

#include <linux/filter.h>
#include "bpf_filter.h"


/* iphdr - 40 octets */
//̰  _ʿ
static struct sock_filter ad_hoc_filter[] = {
	/*IP Version Check */
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_ABS, 	0),
	BPF_STMT(BPF_ALU+BPF_AND+BPF_K, 0xf0),
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_VERSION,	1,	 0),
	BPF_STMT(BPF_RET+BPF_K, 0), /* Pass packet */
	/*HOP By HOP ? */
	BPF_STMT(BPF_LD+BPF_B+BPF_ABS, 	6),
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_HOPBYHOP, 	0, 2),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*#0 DST OPT ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_DSTOPT, 	0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*TYPE 0 ROUTING HDR ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_ROUTING,  	0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*TYPE 2 ROUTING HDR ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_ROUTING,  	0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*FRAGMEMT HDR ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_FRAG, 	0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*AH HDR ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_AH, 		0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*ESP HDR ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_ESP, 	0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*#1 DST OPT ? */
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_DSTOPT, 	0, 10),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	/*NO HDR ?*/
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IP_EXT_HDR_NOHDR, 	0, 1),	
	BPF_STMT(BPF_RET+BPF_K, 0), /* Pass packet */

	/*ϴ icmp TYPEΰ*/
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, IPPROTO_ICMPV6, 	 0, 12),
	BPF_STMT(BPF_MISC+BPF_TXA, 	0),
	BPF_JUMP(BPF_JMP+BPF_JGE+BPF_K, 40, 	2, 0),
	BPF_STMT(BPF_LDX+BPF_W+BPF_IMM,	40),
	BPF_JUMP(BPF_JMP+BPF_JA, 	5, 	0, 0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	1),
	BPF_STMT(BPF_ALU+BPF_MUL+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_K, 8),
	BPF_STMT(BPF_ALU+BPF_ADD+BPF_X, 0),
	BPF_STMT(BPF_MISC+BPF_TAX, 	0),
	BPF_STMT(BPF_LD+BPF_B+BPF_IND, 	0),
	BPF_JUMP(BPF_JMP+BPF_JEQ+BPF_K, ICMPV6_AD_HOC,  	0, 1),
	BPF_STMT(BPF_RET+BPF_K, (__u32)-1), /* accept the packet */
	BPF_STMT(BPF_RET+BPF_K, 0) /* Pass packet */		
};



static struct sock_fprog  ad_hoc_fprog = {sizeof(ad_hoc_filter)/sizeof(struct sock_filter), ad_hoc_filter };


/**
 * open_BPF_socket:
 * @dev: 
 * 
 * Returns: BPF socket
 */

//socket ip   filteringϿ ϴ MSG ޴´.
int open_BPF_socket(char *device)
{
	int s, i;
	struct sockaddr_ll sa;
	struct ifreq ifr;

	
	memset(&ifr, 0, sizeof(ifr));
	memset(&sa, 0, sizeof(sa));
	
       //PF_PACKET : Low level packet interface     
	s = socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_IPV6));
	if (s < 0) {
		if (errno == EPERM) 
			printf("[open_XXXX_socket()] Must be run as root\n");
		printf("[open_XXXX_socket()] socket: %s\n", strerror(errno));
		return -1;
	}


	if(setsockopt(s, SOL_SOCKET, SO_ATTACH_FILTER, &ad_hoc_fprog, sizeof(ad_hoc_fprog)) < 0) {
		printf("[open_XXXX_socket() res ] setsockopt: %s\n", strerror(errno));
		return -1;
	}

	i = strlen(device);
	if (i >= sizeof(ifr.ifr_name)) {
		printf("[open_XXXX_socket()] too long interface parameter\n");
		return -1;
	}

	memcpy(ifr.ifr_name, device, i + 1);
	if (ioctl(s, SIOCGIFINDEX, &ifr) != 0) {
		printf("[open_XXXX_socket()] ioctl: %s\n", strerror(errno));
		close(s);
		return -1;
	}
	//interface index copy
	sa.sll_family = AF_PACKET;
	sa.sll_ifindex = ifr.ifr_ifindex;
	
        //socket interface assignѴ.
	if (bind(s, (struct sockaddr *)&sa, sizeof(sa)) < 0) {
		printf("[open_xxxx_socket()]  bind: %s\n",strerror(errno));
		return -1;
	}

	return s;
}


