#ifndef _DEBUG_H
#define _DEBUG_H

#include <stdio.h>
#include <stdarg.h>

/* DEBUG */

#ifdef NODEBUGMODE
#define DEBUG nodebug
#define DEBUG_HEXDUMP(...)
#define DEBUG_FUNC() DEBUG
#else
#define DEBUG debug
#define DEBUG_HEXDUMP debug_hexdump
//#define DEBUG_FUNC() DEBUG("FUNCTION \n")
#define DEBUG_FUNC() DEBUG( "%s(%d)/%s: \n", __FILE__,__LINE__,__FUNCTION__)
#endif

/* prototypes */
#define CHECK_FORMAT __attribute__ ((format (printf, 1, 2)))
void debug(char *format, ...) CHECK_FORMAT;
void nodebug(char *format, ...) CHECK_FORMAT;
void debug_hexdump(const char *title, const unsigned char *buf,int len);

#endif /* DEBUG_H */
