#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <syslog.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <fnmatch.h>
#include <linux/if_packet.h>
#include <linux/if.h>
#include <sys/time.h>
#include <asm/byteorder.h>
#include <pthread.h>

#include "dis_peers.h"
#include "bpf_filter.h"
#include "callbacks.h"
#include "network_util.h"



#define max(a,b) (((a)>(b))?(a):(b))

extern struct peer_config config;

void peer_expire(struct peers_info_entry *peer);
void adgw_expire(struct peers_info_entry *peer);


//packet passingϰ   ġ ȯѴ 
int detect_packet_type(unsigned char * buf, int* len)
{
	unsigned char * packet=buf;
	unsigned char value=0;
	int header_len =0 ;
	int 	pos=0, total_len =* len;
	
	/*ip header ؼ*/
	value = (unsigned char) *(packet +6); //Next Header
	
	for( ; pos < total_len; )
	{
		switch(value)
		{
			case IP_EXT_HDR_HOPBYHOP:
			case IP_EXT_HDR_ROUTING:
			case IP_EXT_HDR_FRAG:
			case IP_EXT_HDR_DSTOPT:
			case IP_EXT_HDR_ESP:
			case IP_EXT_HDR_AH:
				if (pos ==0){
					pos =40;
				}else{
					header_len = (unsigned char) *(packet +pos +1); //Extend Heder Length
					header_len = header_len*8 +8;  //8 1 unit̰ ó 8  ̹Ƿ 
					pos += header_len;
				}
				value = (unsigned char) *(packet +pos); //Next Header
				break;
				
			case IP_EXT_HDR_NOHDR:
				printf("[detect_packet_type()] NO HEADR TYPE\n");
				return -1;

			case  IPPROTO_ICMPV6:
				if (pos ==0){
					pos =40;
				}else{
					header_len = (unsigned char) *(packet +pos +1); //Extend Heder Length
					header_len = header_len*8 +8;  //8 1 unit̰ ó 8  ̹Ƿ 
					pos += header_len;
				}
				*len = pos;
				return  value;
			default:
				printf("[detect_packet_type()] Unkown type : type [%d]\n",value);
				return -1;
		}
	}

	return -1;
}




int handle_adhoc_msg(void)
{
	fd_set set;
	int max_fd =0, result;
	struct timeval callback_time, tv;	

	memset(&tv, 0, sizeof(struct timeval));
	memset(&callback_time, 0, sizeof(struct timeval));
	gettimeofday(&callback_time, NULL);
	
	for( ;; )
	{
		time_handle(&callback_time, &tv);	
		FD_ZERO(&set);

		FD_SET(config.chat_sock, &set);
		max_fd = max(max_fd, config.chat_sock);

		if( !list_empty(&config.devices) )
		{
			struct list_head *p;
			
			list_for_each( p, &config.devices)		
			{
				struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);

				FD_SET(entry->socks.bpf_sock, &set);
				max_fd = max(max_fd, entry->socks.bpf_sock);
				FD_SET(entry->socks.udp_sock, &set);
				max_fd = max(max_fd, entry->socks.udp_sock);				
			}
		}

		if( (result = select(max_fd+1, &set, NULL, NULL, &tv)) < 0) 
		{
	 		if (errno != EINTR) 
			{
				printf("[handle_adhoc_msg] select - %s \n", strerror(errno));
				exit(1);
			}
				continue;
		}

		if (FD_ISSET(config.chat_sock, &set)) 
			receive_udp_process(NULL, config.chat_sock);				

		if( !list_empty(&config.devices) )
		{
			struct list_head* lead = &config.devices;
			struct list_head *p,*n;

			list_for_each_safe(p, n, lead)			
			{
				struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);
				
				if (FD_ISSET(entry->socks.udp_sock, &set)) 
					receive_udp_process(entry, entry->socks.udp_sock);				
				
				if (FD_ISSET(entry->socks.bpf_sock, &set)) 
					receive_icmp_process(entry, entry->socks.bpf_sock);		
			}
		}

		if (result == 0)
		{
			if( config.mode != ADHOC_DELAY_MODE )
				adhoc_advertisement();

			expire_entry_time_handle();
		}	
	}
	pthread_exit(0);	
}


int receive_udp_process(struct interface_info_entry *iface, int sock)
{
	int len;
	struct sockaddr_in6  from;
	unsigned int fromlen;
	unsigned char buf[MAX_MSG_LEN]={0x00,};
	char code=0;
	
	memset(&from, 0,sizeof(struct sockaddr_in6) );
	fromlen = sizeof(struct sockaddr_in6);
	len = recvfrom(sock, buf, sizeof(buf), 0, (struct sockaddr *)&from, &fromlen);
	if (len < 0) {
    	  printf("[receive_udp_process()] recvfrom: %s\n", strerror(errno));
		return -1;
	}
	
	code=buf[0];
	
	if (code < 0) {
		printf("[IM][receive_processe()] Unkown Packet type\n");
		return -1;
	}

	switch (code) {
		
		case DISCOVER_PEERS_RESPONSE :
			debug_hexdump("RCV DISCOVER_PEERS_RESPONSE", buf, len);			
			return handle_dis_peers_res(iface, buf, len);

		case ADGW_JOIN_REQUEST :
			debug_hexdump("REV ADGW_JOIN_REQUEST", buf, len);			
			return handle_adgw_join_req(iface, buf, len);

		case ADGW_JOIN_RESPONSE :
			debug_hexdump("REV ADGW_JOIN_RESPONSE", buf, len);			
			return handle_adgw_join_res(iface, buf, len);

		case SCATTER_PEERS_SOL :
			debug_hexdump("REV SCATTER_PEERS_SOL", buf, len);	
			return handle_scatter_peers_sol(iface, buf, len);

		case SCATTER_PEERS_ADV :
			debug_hexdump("REV SCATTER_PEERS_ADV", buf, len);	
			return handle_scatter_peers_adv(iface, buf, len);

		case CHAT_MESSAGE :
			debug_hexdump("REV CHAT_MESSAGE", buf, len);						
			return handle_chat_message(iface, buf, len);

		case CONFERENCE_CONNECT_REQUEST :
			debug_hexdump("REV CONFERENCE_CONNECT_REQUEST", buf, len);	
			return handle_conference_connect_request(iface, buf, len);

		case CONFERENCE_CONNECT_RESPONSE :
			debug_hexdump("REV CONFERENCE_CONNECT_RESPONSE", buf, len);	
			return handle_conference_connect_response(iface, buf, len);
			
		default :
			break;
	}

	return -1;	
}


int receive_icmp_process(struct interface_info_entry *iface, int sock)
{
	int len, pos;
	struct sockaddr_ll  from;
	unsigned int fromlen;
	unsigned char buf[MAX_MSG_LEN]={0x00,};
	int type = 0;
	unsigned char *msg_pos;

	ipv6Hdr *ip6hdr;

	fromlen = sizeof(struct sockaddr_ll);

	len = recvfrom(sock, buf, sizeof(buf), 0, (struct sockaddr *)&from, &fromlen);

	if (len < 0)
		return -1;
        
	pos = len;
	type= detect_packet_type(buf, &pos);

	ip6hdr = (ipv6Hdr *)buf;
	msg_pos = (char *) (buf + pos);
	pos  = len-pos;

	if (type < 0) 
		return -1;

	switch (*(msg_pos+sizeof(Dis_peers_msg))) {
		case DISCOVER_PEERS_REQUEST :
			print_icmp_msg_info("REDV DISCOVER_PEERS_REQUEST", iface->dev_name, msg_pos, pos, (struct in6_addr*)ip6hdr->src);			
			return handle_dis_peers_req(iface, msg_pos, pos);

		case ADVERTISEMENT_ADHOCGW :
			print_icmp_msg_info("RECV ADVERTISEMENT_ADHOCGW", iface->dev_name, msg_pos, pos, (struct in6_addr*)ip6hdr->src);									
			return handle_dis_adgw_adv(iface, msg_pos, pos);
			
		default :
			printf("[receive_process()] Unkown Packet : code [%d]\n", *(msg_pos+sizeof(Dis_peers_msg)));
			break;
	}

	return -1;	
}


int handle_conference_connect_request(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Dis_peers_msg *msg;
	Option_header *hdr;
	Conference_info_opt *opt;

	struct peers_info_entry *peer=NULL;

	printf("[handle_conference_connect_request] start\n");	
	
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Conference_info_opt*)pos;

	if( (peer = search_peer_by_nick(opt->nickname.nick)) == NULL )
	{
		if((peer = search_adgw_by_nick(opt->nickname.nick)) == NULL)
		{
			printf("[handle_conference_connect_request] Not found peer [%s]\n", opt->nickname.nick);
	 		return ;			
		}
	}
	printf("[handle_conference_connect_request] Received conference calling. from [%s]\n", peer->nickname.nick);
	
	thread_popup_conference(opt->type, peer);

	return ;
}

int handle_conference_connect_response(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Dis_peers_msg *msg;
	Option_header *hdr;
	Conference_info_opt *opt;

	struct peers_info_entry *peer=NULL;
	struct in6_addr addr;
	
	printf("[handle_conference_connect_response] start\n");	
	
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Conference_info_opt*)pos;

	if( (peer = search_peer_by_nick(opt->nickname.nick)) == NULL )
	{
		if((peer = search_adgw_by_nick(opt->nickname.nick)) == NULL)
		{
			printf("[handle_conference_connect_response] Not found peer [%s]\n", opt->nickname.nick);
	 		return ;			
		}
	}
	printf("[handle_conference_connect_response] Received conference answer. from [%s]\n", peer->nickname.nick);
	
	if( opt->code == CONNECTION_REFUSE )
	{
		char s_buf[128]={0x00,};

		sprintf(s_buf, "Conference calling refused. from [%s]\n", peer->nickname.nick);
		thread_popup_error(s_buf);
		return ;
	}

	if(peer->status == CONFIRMED_SCATTER_PEER)
		memcpy(&addr, peer->g_address.address, sizeof(struct in6_addr));
	else
		memcpy(&addr, peer->s_address.address, sizeof(struct in6_addr));

	switch(opt->type)
	{
		case CONFERENCE_ALL :
			run_skt_conference_rat(&addr, DEFAULT_RAT_PORT);
			run_skt_conference_vic(&addr, DEFAULT_VIC_PORT);
			break;
		case CONFERENCE_VIC:
			run_skt_conference_vic(&addr, DEFAULT_VIC_PORT);
			break;
		case CONFERENCE_RAT :
			run_skt_conference_rat(&addr, DEFAULT_RAT_PORT);
			break;
		default :
			break;
	}

	return ;
}


int handle_chat_message(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Option_header *hdr;
	Message_info_opt *opt;

	struct peers_info_entry *peer=NULL;

	printf("[handle_chat_message] start\n");	
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Message_info_opt *)pos;

	if( (peer = search_peer_by_nick(opt->nickname.nick)) == NULL )
	{
		if((peer = search_adgw_by_nick(opt->nickname.nick)) == NULL)
		{
			printf("[handle_chat_message] Not found peer [%s]\n", opt->nickname.nick);
	 		return ;			
		}
	}

	popup_rcv_message(opt->nickname.nick, opt->msg);
	printf("[handle_chat_message] end\n");	
	return 0;
}


int handle_dis_peers_req(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Dis_peers_msg *msg;
	Option_header *hdr;
	Peers_info_opt *opt;

	struct peers_info_entry *peer=NULL;
	struct interface_info_entry *tmp_iface;

	int refresh=FALSE;

	printf("[handle_dis_peers_req] start\n");	
	
	msg = (Dis_peers_msg *)pos;
	pos += DIS_PEERS_MSG_SIZE;
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Peers_info_opt *)pos;

	if( ( tmp_iface = search_interface_by_lladdress(opt->ll_address.address)) != NULL )
		return -1;

	if( opt->mode != ADHOC_LINK_MODE )
	{
		printf("[handle_dis_peers_req] Peer(%s) mode is not ADHOC_LINK_MODE : Discard DISCOVER_PEERS_REQUEST\n", opt->nickname.nick);
		return -1;
	}
	else
	{
		if( (peer = search_adgw_by_lladdress(opt->ll_address.address) ) != NULL )
		{
			printf("[handle_dis_peers_req] Change peer mode : [%d] --> [%d]\n", peer->mode, opt->mode);
			if( config.curr_adhoc_gw == peer )
			{
				printf("\t Peer is current ad-hoc gateway!!\n");
				config.curr_adhoc_gw = NULL;
				iface->scope = REACHABLE_LINK_SCOPE;
				flush_scatter_peers();

				default_router_del(iface->dev_name, NULL);
				addr_del(iface->dev_name, (struct in6_addr *)iface->g_address.address, iface->g_address.prefixlen);
				memset(&iface->g_address, 0, ADDRESS_INFO_SIZE);

				refresh = TRUE;
			}
			del_list_entry((struct list_head *)peer);
		}
		
		if( (peer = search_peer_by_lladdress(opt->ll_address.address) ) == NULL )
		{
			// ο Ʈ ߰.
			peer = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
			memset(peer, 0, sizeof(struct peers_info_entry));

			strcpy(peer->dev_index, iface->dev_name);
			peer->mode = opt->mode;
			peer->status = UNCONFIRMED_LINK_PEER;

			memcpy(&peer->mac_address, &opt->mac_address, MAC_INFO_SIZE);
			memcpy(&peer->ll_address, &opt->ll_address, ADDRESS_INFO_SIZE);
			memcpy(&peer->s_address, &opt->s_address, ADDRESS_INFO_SIZE);	
			
			memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);

			peer->lifetime = DEFAULT_PEER_LIFETIME;
			peer->callback_function = peer_expire;

			add_peers_entry(peer);

			neigh_add(iface->dev_name, (struct in6_addr *)peer->s_address.address, peer->mac_address);

			refresh = TRUE;
			
			printf("[handle_dis_peers_req] New LINK PEER nick[%s]\n", peer->nickname.nick);
			debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
			debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);		
		}
		else
		{
			if( config.mode == ADHOC_LINK_MODE )
				if( peer->status == CONFIRMED_SCATTER_PEER )
				{
					printf("[handle_dis_peers_req] Change peer[%s] reachable status : SCATTER --> LINK\n", peer->nickname.nick);
					peer->status = UNCONFIRMED_LINK_PEER;
					memset(&peer->g_address, 0, ADDRESS_INFO_SIZE);
					refresh = TRUE;
				}

			if( strcmp(peer->nickname.nick, opt->nickname.nick) )
			{
				printf("[handle_dis_peers_req] Change peer Nickname[%s]-->[%s] \n", peer->nickname.nick, opt->nickname.nick);
				memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);
				refresh = TRUE;				
			}
			
			neigh_add(iface->dev_name, (struct in6_addr *)peer->s_address.address, peer->mac_address);

			peer->lifetime = DEFAULT_PEER_LIFETIME;
			peer->callback_function = peer_expire;
			
			printf("[handle_dis_peers_req] OLD PEER nick[%s]\n", peer->nickname.nick);
			debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
			debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);			
		}	
	}
	
	send_dis_peers_res(iface, msg->identifier, peer);

	if( refresh )
		thread_rebuild_peer_list();
	
	printf("[handle_dis_peers_req] end\n");		
	
	return 0;
}


int handle_dis_peers_res(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Dis_peers_msg *msg;
	Option_header *hdr;
	Peers_info_opt *opt;

	struct peers_info_entry *peer=NULL;
	struct interface_info_entry *tmp_iface;

	int refresh = FALSE;
	
	printf("[handle_dis_peers_res] start\n");		
	
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Peers_info_opt *)pos;

//	msg->identifier ˻ Ѵ.
	if( ( tmp_iface = search_interface_by_lladdress(opt->ll_address.address)) != NULL )
		return -1;
	
	if( opt->mode == ADHOC_DELAY_MODE )
	{
		printf("[handle_dis_peers_res] Peer(%s) mode is ADHOC_DELAY_MODE : Discard DISCOVER_PEERS_RESPONSE\n", opt->nickname.nick);
		return -1;
	}
	
	if( opt->mode == ADHOC_LINK_MODE )
	{
		if( (peer = search_adgw_by_lladdress(opt->ll_address.address) ) != NULL )
		{
			printf("[handle_dis_peers_res] Change peer mode : [%d] --> [%d]\n", peer->mode, opt->mode);
			if( config.curr_adhoc_gw == peer )
			{
				printf("\t Peer is current ad-hoc gateway!!\n");
				config.curr_adhoc_gw = NULL;
				iface->scope = REACHABLE_LINK_SCOPE;
				flush_scatter_peers();

				default_router_del(iface->dev_name, NULL);
				addr_del(iface->dev_name, (struct in6_addr *)iface->g_address.address, iface->g_address.prefixlen);
				memset(&iface->g_address, 0, ADDRESS_INFO_SIZE);

				refresh = TRUE;
			}
			del_list_entry((struct list_head *)peer);
		}
			
		if( (peer = search_peer_by_lladdress(opt->ll_address.address) ) == NULL )
		{
			// ο Ʈ ߰.
			peer = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
			memset(peer, 0, sizeof(struct peers_info_entry));

			strcpy(peer->dev_index, iface->dev_name);
			peer->mode = opt->mode;
			peer->status = UNCONFIRMED_LINK_PEER;

			memcpy(&peer->mac_address, &opt->mac_address, MAC_INFO_SIZE);
			memcpy(&peer->ll_address, &opt->ll_address, ADDRESS_INFO_SIZE);
			memcpy(&peer->s_address, &opt->s_address, ADDRESS_INFO_SIZE);	
			
			memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);

			peer->lifetime = DEFAULT_PEER_LIFETIME;
			peer->callback_function = peer_expire;

			add_peers_entry(peer);

			neigh_add(iface->dev_name, (struct in6_addr *)peer->s_address.address, peer->mac_address);

			refresh = TRUE;
			
			printf("[handle_dis_peers_res] New LINK PEER nick[%s]\n", peer->nickname.nick);
			debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
			debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);		
		}
		else
		{
			if( config.mode == ADHOC_LINK_MODE )
				if( peer->status == CONFIRMED_SCATTER_PEER )
				{
					printf("[handle_dis_peers_res] Change peer[%s] reachable status : SCATTER --> LINK\n", peer->nickname.nick);
					peer->status = UNCONFIRMED_LINK_PEER;
					memset(&peer->g_address, 0, ADDRESS_INFO_SIZE);
					refresh = TRUE;
				}

			if( strcmp(peer->nickname.nick, opt->nickname.nick) )
			{
				printf("[handle_dis_peers_res] Change peer Nickname[%s]-->[%s] \n", peer->nickname.nick, opt->nickname.nick);
				memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);
				refresh = TRUE;				
			}
			
			neigh_add(iface->dev_name, (struct in6_addr *)peer->s_address.address, peer->mac_address);

			peer->lifetime = DEFAULT_PEER_LIFETIME;
			peer->callback_function = peer_expire;
			
			printf("[handle_dis_peers_res] OLD PEER nick[%s]\n", peer->nickname.nick);
			debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
			debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);			
		}	
	}	
	else if( opt->mode > ADHOC_LINK_MODE )
	{
		if( (peer = search_peer_by_lladdress(opt->ll_address.address) ) != NULL )
		{
			printf("[handle_dis_peers_res] Change adgw mode : [%d] --> [%d]\n", peer->mode, opt->mode);
			del_list_entry((struct list_head *)peer);
		}
		if( (peer = search_adgw_by_lladdress(opt->ll_address.address) ) == NULL )
		{
			// ο Ʈ ߰.
			peer = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
			memset(peer, 0, sizeof(struct peers_info_entry));

			strcpy(peer->dev_index, iface->dev_name);
			peer->mode = opt->mode;
			peer->status = UNCONFIRMED_LINK_PEER;

			memcpy(&peer->mac_address, &opt->mac_address, MAC_INFO_SIZE);
			memcpy(&peer->ll_address, &opt->ll_address, ADDRESS_INFO_SIZE);
			memcpy(&peer->s_address, &opt->s_address, ADDRESS_INFO_SIZE);	
			memcpy(&peer->g_address, &opt->g_address, ADDRESS_INFO_SIZE);			
			memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);

			peer->lifetime = DEFAULT_PEER_LIFETIME;
			peer->callback_function = adgw_expire;

			add_adgw_entry(peer);

			neigh_add(iface->dev_name, (struct in6_addr *)peer->s_address.address, peer->mac_address);

			refresh = TRUE;
			
			printf("[handle_dis_peers_res] New LINK ADGW nick[%s]\n", peer->nickname.nick);
			debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
			debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);	
			debug_hexdump("Global address :  ", peer->g_address.address, 16);				
		}
		else
		{
			if( peer->mode != opt->mode )
			{
				printf("[handle_dis_peers_res] Change adgw[%]s mode\n", opt->nickname.nick);

				if( opt->mode == ADHOC_SCATTER_MODE )
					printf("\t ADHOC_PROXY_MODE --> ADHOC_SCATTER_MODE\n");	
				else
					printf("\t ADHOC_SCATTER_MODE --> ADHOC_PROXY_MODE\n");						
				
				peer->mode = opt->mode;
				memcpy(&peer->g_address, &opt->g_address, ADDRESS_INFO_SIZE);
				
				if( config.curr_adhoc_gw == peer )
				{
					printf("\t Peer is current ad-hoc gateway!!\n");
					config.curr_adhoc_gw = NULL;
					iface->scope = REACHABLE_LINK_SCOPE;
					flush_scatter_peers();
					default_router_del(iface->dev_name, NULL);
					addr_del(iface->dev_name, (struct in6_addr *)iface->g_address.address, iface->g_address.prefixlen);
					memset(&iface->g_address, 0, ADDRESS_INFO_SIZE);

					send_adgw_join_req(iface, peer);
					refresh = TRUE;
				}
			}
			if( strcmp(peer->nickname.nick, opt->nickname.nick) )
			{
				printf("[handle_dis_peers_res] Change peer Nickname[%s]-->[%s] \n", peer->nickname.nick, opt->nickname.nick);
				memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);
				refresh = TRUE;				
			}
			
			neigh_add(iface->dev_name, (struct in6_addr *)peer->s_address.address, peer->mac_address);

			peer->lifetime = DEFAULT_PEER_LIFETIME;
			peer->callback_function = adgw_expire;
			
			printf("[handle_dis_peers_res] OLD PEER nick[%s]\n", peer->nickname.nick);
			debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
			debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);
			debug_hexdump("Global address :  ", peer->g_address.address, 16);				
		}
	}

	if( refresh )
		thread_rebuild_peer_list();
	
	printf("[handle_dis_peers_res] end\n");		
	
	return 0;
}


int handle_dis_adgw_adv(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Dis_peers_msg *msg;
	Option_header *hdr;
	Peers_info_opt *opt;

	struct peers_info_entry *adgw=NULL;
	struct interface_info_entry *tmp_iface;

	int refresh = FALSE;
	
	printf("[handle_dis_adgw_adv] start\n");		

	msg = (Dis_peers_msg *)pos;
	pos += DIS_PEERS_MSG_SIZE;
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Peers_info_opt *)pos;

//	msg->identifier ˻ Ѵ.

	if( (opt->mode < ADHOC_SCATTER_MODE) || (opt->mode == ADHOC_DELAY_MODE ))
		return -1;

	if( ( tmp_iface = search_interface_by_lladdress(opt->ll_address.address)) != NULL )
		return -1;
	
	if( (adgw = search_peer_by_lladdress(opt->ll_address.address) ) != NULL )
	{
		printf("[handle_dis_adgw_adv] Change adgw mode : [%d] --> [%d]\n", adgw->mode, opt->mode);
		del_list_entry((struct list_head *)adgw);
	}
	if( (adgw = search_adgw_by_lladdress(opt->ll_address.address) ) == NULL )
	{
		// ο Ʈ ߰.
		adgw = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
		memset(adgw, 0, sizeof(struct peers_info_entry));

		strcpy(adgw->dev_index, iface->dev_name);
		adgw->mode = opt->mode;
		adgw->status = UNCONFIRMED_LINK_PEER;

		memcpy(&adgw->mac_address, &opt->mac_address, MAC_INFO_SIZE);
		memcpy(&adgw->ll_address, &opt->ll_address, ADDRESS_INFO_SIZE);
		memcpy(&adgw->s_address, &opt->s_address, ADDRESS_INFO_SIZE);	
		memcpy(&adgw->g_address, &opt->g_address, ADDRESS_INFO_SIZE);			
		memcpy(&adgw->nickname, &opt->nickname, NICKNAME_INFO_SIZE);

		adgw->lifetime = DEFAULT_PEER_LIFETIME;
		adgw->callback_function = adgw_expire;

		add_adgw_entry(adgw);

		neigh_add(iface->dev_name, (struct in6_addr *)adgw->s_address.address, adgw->mac_address);

		refresh = TRUE;
		
		printf("[handle_dis_adgw_adv] New LINK ADGW nick[%s]\n", adgw->nickname.nick);
		debug_hexdump("Link-local address :  ", adgw->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", adgw->s_address.address, 16);	
		debug_hexdump("Global address :  ", adgw->g_address.address, 16);				
	}
	else
	{
		if( adgw->mode != opt->mode )
		{
			printf("[handle_dis_adgw_adv] Change adgw[%]s mode\n", opt->nickname.nick);

			if( opt->mode == ADHOC_SCATTER_MODE )
				printf("\t ADHOC_PROXY_MODE --> ADHOC_SCATTER_MODE\n");	
			else
				printf("\t ADHOC_SCATTER_MODE --> ADHOC_PROXY_MODE\n");						
			
			adgw->mode = opt->mode;
			memcpy(&adgw->g_address, &opt->g_address, ADDRESS_INFO_SIZE);
			
			if( config.curr_adhoc_gw == adgw )
			{
				printf("\t Peer is current ad-hoc gateway!!\n");
				config.curr_adhoc_gw = NULL;
				iface->scope = REACHABLE_LINK_SCOPE;
				flush_scatter_peers();
				default_router_del(iface->dev_name, NULL);
				addr_del(iface->dev_name, (struct in6_addr *)iface->g_address.address, iface->g_address.prefixlen);
				memset(&iface->g_address, 0, ADDRESS_INFO_SIZE);

				send_adgw_join_req(iface, adgw);
			}
			refresh = TRUE;			
		}
		if( strcmp(adgw->nickname.nick, opt->nickname.nick) )
		{
			printf("[handle_dis_adgw_adv] Change peer Nickname[%s]-->[%s] \n", adgw->nickname.nick, opt->nickname.nick);
			memcpy(&adgw->nickname, &opt->nickname, NICKNAME_INFO_SIZE);
			refresh = TRUE;				
		}
		
		neigh_add(iface->dev_name, (struct in6_addr *)adgw->s_address.address, adgw->mac_address);

		adgw->lifetime = DEFAULT_PEER_LIFETIME;
		adgw->callback_function = adgw_expire;
		
		printf("[handle_dis_adgw_adv] OLD PEER nick[%s]\n", adgw->nickname.nick);
		debug_hexdump("Link-local address :  ", adgw->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", adgw->s_address.address, 16);
		debug_hexdump("Global address :  ", adgw->g_address.address, 16);				
	}
	
//	if(iface->curr_adhoc_gw == NULL)
//		send_adgw_join_req(iface, adgw);
//	else
	send_dis_peers_res(iface, msg->identifier, adgw);

	if(refresh )
		thread_rebuild_peer_list();
	
	printf("[handle_dis_adgw_adv] end\n");		

	return ;
}

int handle_adgw_join_req(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Option_header *hdr;
	Peers_info_opt *opt;

	struct peers_info_entry *peer=NULL;
	struct interface_info_entry *tmp_iface;

	int refresh = FALSE;
	
	printf("[handle_adgw_join_req] start\n");		

	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Peers_info_opt *)pos;
	pos += PEERS_INFO_OPT_SIZE;

	if( config.mode < ADHOC_SCATTER_MODE )
	{
		printf("[handle_adgw_join_req] : Not supported ADGW JOIN [%s]\n", iface->dev_name);
		return -1;
	}

	if( ( tmp_iface = search_interface_by_lladdress(opt->ll_address.address)) != NULL )
		return -1;

	if( (peer = search_peer_by_lladdress(opt->ll_address.address)) == NULL )
	{
		// ο Ʈ ߰.
		peer = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
		memset(peer, 0, sizeof(struct peers_info_entry));

		strcpy(peer->dev_index, iface->dev_name);
		peer->mode = opt->mode;
		peer->status = CONFIRMED_SCATTER_PEER;

		memcpy(&peer->mac_address, &opt->mac_address, MAC_INFO_SIZE);
		memcpy(&peer->ll_address, &opt->ll_address, ADDRESS_INFO_SIZE);
		memcpy(&peer->s_address, &opt->s_address, ADDRESS_INFO_SIZE);	
		memcpy(&peer->g_address, &opt->g_address, ADDRESS_INFO_SIZE);			
		memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);

		peer->lifetime = DEFAULT_PEER_LIFETIME;
		peer->callback_function = peer_expire;

		add_peers_entry(peer);

		neigh_add(iface->dev_name, (struct in6_addr *)peer->g_address.address, peer->mac_address);

		refresh = TRUE;
		
		printf("[handle_adgw_join_req] NEW PEER nick[%s]\n", peer->nickname.nick);
		debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);	
		debug_hexdump("Global address :  ", peer->g_address.address, 16);	
	}
	else
	{
		if( strcmp( peer->dev_index, iface->dev_name) )
		{
			printf("[handle_adgw_join_req] Change peer's incomming interface [%s] --> [%s]\n", peer->dev_index, iface->dev_name);
			neigh_del(peer->dev_index, (struct in6_addr *)peer->s_address.address);
			neigh_del(peer->dev_index, (struct in6_addr *)peer->g_address.address);
			strcpy(peer->dev_index, iface->dev_name);

			refresh = TRUE;
		}
		if( peer->mode != opt->mode )
		{
			printf("[handle_adgw_join_req]  Change peer[%s]'s mode [%d]-->[%d'\n", peer->nickname.nick, peer->mode, opt->mode);
			peer->mode = opt->mode;

			refresh = TRUE;
		}
		if( peer->status == UNCONFIRMED_LINK_PEER )
		{
			printf("[handle_adgw_join_req]  Change peer[%s]'s status UNCONFIRMED_LINK_PEER --> CONFIRMED_SCATTER_PEER\n", peer->nickname.nick);
			peer->status = CONFIRMED_SCATTER_PEER;
			memcpy(&peer->g_address, &opt->g_address, ADDRESS_INFO_SIZE);	

			refresh = TRUE;
		}
		if( strcmp( peer->nickname.nick, opt->nickname.nick) )
		{
			printf("[handle_adgw_join_req]  Change peer[%s]'s nickname --> [%s]\n", peer->nickname.nick, opt->nickname.nick);
			memcpy(&peer->nickname, &opt->nickname, NICKNAME_INFO_SIZE);		

			refresh = TRUE;			
		}

		peer->lifetime = DEFAULT_PEER_LIFETIME;
		peer->callback_function = peer_expire;
		
		neigh_add(iface->dev_name, (struct in6_addr *)peer->g_address.address, peer->mac_address);		

		printf("[handle_adgw_join_req] OLD PEER nick[%s]\n", peer->nickname.nick);
		debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);	
		debug_hexdump("Global address :  ", peer->g_address.address, 16);			
	}		

	send_adgw_join_res(iface, peer);

	if( (config.mode == ADHOC_PROXY_MODE)&&(config.proxy_if != NULL) )
	{
		send_ndisc_na(config.proxy_if->socks.icmpv6_sock, config.proxy_if->ifindex, config.proxy_if->mac, (struct in6_addr*)peer->g_address.address, FALSE);
		neigh_add_proxy(config.proxy_if->dev_name, (struct in6_addr *)peer->g_address.address);
	}

	if( refresh )
		thread_rebuild_peer_list();

	if( !list_empty(&config.devices) )
	{
		struct list_head* lead = &config.devices;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)		
		{
			struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( (entry->ifmode == WIRELESS_INTERFACE) && (entry->curr_wlan_info.mode == IW_MODE_ADHOC) )
				if( strcmp(peer->dev_index, entry->dev_name) )
					send_scatter_peers_adv(entry, NULL);
		}
	}
	
	printf("[handle_adgw_join_req] end\n");		
	return 0;
}


int handle_adgw_join_res(struct interface_info_entry *iface, char *buf, int len)
{
	int count;
	unsigned char *pos = buf;
	Option_header *hdr;
	Peers_info_opt *adgw_opt, *peer_opt;

	struct peers_info_entry *adgw=NULL, *peer=NULL;
	struct interface_info_entry *tmp_iface;	

	printf("[handle_adgw_join_res] start\n");		
	
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	adgw_opt = (Peers_info_opt *)pos;
	pos += PEERS_INFO_OPT_SIZE;

//	msg->identifier ˻ Ѵ.
	if( (adgw_opt->mode < ADHOC_SCATTER_MODE) && (adgw_opt->mode == ADHOC_DELAY_MODE))
		return -1;

	if( ( tmp_iface = search_interface_by_lladdress(adgw_opt->ll_address.address)) != NULL )
		return -1;
	
	if( (adgw = search_adgw_by_lladdress(adgw_opt->ll_address.address)) == NULL )
	{
		printf("[handle_adgw_join_res] Not found adhoc gateway [%s]\n", adgw_opt->nickname.nick);
		return -1;
	}

//	change_autoconf_status(iface->dev_name, AUTOCONF_DISABLE);

	if( iface->scope != REACHABLE_LINK_SCOPE )
	{
		default_router_del(iface->dev_name, NULL);
		neigh_del(iface->dev_name, (struct in6_addr *)config.curr_adhoc_gw->g_address.address);
//		addr_del(iface->dev_name, (struct in6_addr *)config.curr_adhoc_gw->g_address.address, config.curr_adhoc_gw->g_address.prefixlen);

		memset(&iface->g_address, 0, ADDRESS_INFO_SIZE);
		iface->scope = REACHABLE_LINK_SCOPE;
		config.curr_adhoc_gw = NULL;
	}

	if( adgw_opt->mode == ADHOC_SCATTER_MODE )
	{
		strcpy(adgw->dev_index, iface->dev_name);
		adgw->mode = adgw_opt->mode;
		adgw->status = UNCONFIRMED_LINK_PEER;
		
		memcpy(&adgw->g_address, &adgw_opt->g_address, ADDRESS_INFO_SIZE);
		memcpy(&adgw->nickname, &adgw_opt->nickname, NICKNAME_INFO_SIZE);

		global_address_conf(iface->dev_name, adgw->g_address.address, 64, iface->mac, &iface->g_address);
		default_router_add(iface->dev_name, (struct in6_addr *)adgw->g_address.address);
		neigh_add(iface->dev_name, (struct in6_addr *)adgw->g_address.address, adgw->mac_address);
		
		iface->scope = REACHABLE_SCATTER_SCOPE;
	}
	else 
	{
		strcpy(adgw->dev_index, iface->dev_name);
		adgw->mode = adgw_opt->mode;
		adgw->status = UNCONFIRMED_LINK_PEER;
		
		memcpy(&adgw->g_address, &adgw_opt->g_address, ADDRESS_INFO_SIZE);
		memcpy(&adgw->nickname, &adgw_opt->nickname, NICKNAME_INFO_SIZE);

		proxy_global_address_conf(iface->dev_name, adgw->g_address.address, 80, iface->mac, &iface->g_address);
		default_router_add(iface->dev_name, (struct in6_addr *)adgw->g_address.address);
		neigh_add(iface->dev_name, (struct in6_addr *)adgw->g_address.address, adgw->mac_address);
		
		iface->scope = REACHABLE_GLOBAL_SCOPE;	
	}

	adgw->lifetime = DEFAULT_PEER_LIFETIME;
	adgw->callback_function = adgw_expire;

	config.curr_adhoc_gw = adgw;

	flush_scatter_peers();
	
	count = ( (hdr->length - OPTOIN_HEADER_SIZE - PEERS_INFO_OPT_SIZE) / PEERS_INFO_OPT_SIZE);
	while(count)
	{
		peer_opt = (Peers_info_opt *)pos;
		pos += PEERS_INFO_OPT_SIZE;

		// ο Ʈ ߰.
		peer = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
		memset(peer, 0, sizeof(struct peers_info_entry));

		strcpy(peer->dev_index, iface->dev_name);
		peer->mode = peer_opt->mode;
		peer->status = CONFIRMED_SCATTER_PEER;

		memcpy(&peer->ll_address, &peer_opt->ll_address, ADDRESS_INFO_SIZE);
		memcpy(&peer->s_address, &peer_opt->s_address, ADDRESS_INFO_SIZE);		
		memcpy(&peer->g_address, &peer_opt->g_address, ADDRESS_INFO_SIZE);				
		memcpy(&peer->nickname, &peer_opt->nickname, NICKNAME_INFO_SIZE);

		peer->lifetime = DEFAULT_PEER_LIFETIME;
		peer->callback_function = peer_expire;

		add_peers_entry(peer);

		printf("handle_adgw_join_res : NEW SCATTER PEER nick[%s]\n", peer->nickname.nick);
		debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);	
		debug_hexdump("Global address :  ", peer->g_address.address, 16);	

		count--;
	}

	thread_rebuild_peer_list();

	if(1)
	{
		char buf[128]={0x00,};

		sprintf(buf, "Success Connected Ad-hoc gateway[%s]\n", adgw->nickname.nick);
		thread_popup_info(buf);
	}
	printf("[handle_adgw_join_res] end\n");		
	return 0;
}

int handle_scatter_peers_sol(struct interface_info_entry *iface, char *buf, int len)
{
	unsigned char *pos = buf;
	Option_header *hdr;
	Peers_info_opt *opt;

	struct peers_info_entry *peer=NULL;
	struct interface_info_entry *tmp_iface;

	int refresh = FALSE;
	
	printf("[handle_scatter_peers_sol] start\n");		

	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	opt = (Peers_info_opt *)pos;
	pos += PEERS_INFO_OPT_SIZE;

	if( config.mode != ADHOC_SCATTER_MODE )
	{
		printf("[handle_scatter_peers_sol] : Not supported Scatter peers adv [%s]\n", iface->dev_name);
		return -1;
	}

	if( ( tmp_iface = search_interface_by_lladdress(opt->ll_address.address)) != NULL )
		return -1;

	if( (peer = search_peer_by_lladdress(opt->ll_address.address)) == NULL )
	{
		printf("[handle_scatter_peers_sol] : Not found peer [%s]\n", opt->nickname.nick);
		return -1;
	}
	else
	{
		if( strcmp( peer->dev_index, iface->dev_name) )
		{
			printf("[handle_scatter_peers_sol] : Invalid incomming interface [%s]\n", iface->dev_name);
			return -1;			
		}
		if( peer->status == UNCONFIRMED_LINK_PEER )
		{
			printf("[handle_scatter_peers_sol] : Unconfirmed peer [%s]\n", opt->nickname.nick);
			return -1;
		}

		peer->lifetime = DEFAULT_PEER_LIFETIME;
		peer->callback_function = peer_expire;
		
		printf("[handle_scatter_peers_sol] OLD PEER nick[%s]\n", peer->nickname.nick);
		debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);	
		debug_hexdump("Global address :  ", peer->g_address.address, 16);			
	}		

	send_scatter_peers_adv(iface, peer);

	printf("[handle_scatter_peers_sol] end\n");		
	return 0;
}


int handle_scatter_peers_adv(struct interface_info_entry *iface, char *buf, int len)
{
	int count;
	unsigned char *pos = buf;
	Option_header *hdr;
	Peers_info_opt *adgw_opt, *peer_opt;

	struct peers_info_entry *adgw=NULL, *peer=NULL;
	struct interface_info_entry *tmp_iface;	

	printf("[handle_scatter_peers_adv] start\n");		
	
	hdr =  (Option_header *)pos;
	pos+= OPTOIN_HEADER_SIZE;
	adgw_opt = (Peers_info_opt *)pos;
	pos += PEERS_INFO_OPT_SIZE;

	if( adgw_opt->mode != ADHOC_SCATTER_MODE)
		return -1;

	if( ( tmp_iface = search_interface_by_lladdress(adgw_opt->ll_address.address)) != NULL )
		return -1;
	
	if( (adgw = search_adgw_by_lladdress(adgw_opt->ll_address.address)) == NULL )
	{
		printf("[handle_scatter_peers_adv] Not found adhoc gateway [%s]\n", adgw_opt->nickname.nick);
		return -1;
	}

	if( iface->scope != REACHABLE_SCATTER_SCOPE )
	{
		printf("[handle_scatter_peers_adv] Invalid interface[%s] reachable status[%d]\n", iface->dev_name, iface->scope);
		return -1;		
	}

	if( config.curr_adhoc_gw != adgw )
	{
		printf("[handle_scatter_peers_adv] Invalid scatter peers adv, diff current adgw[%s]\n", adgw->nickname.nick);
		return -1;	
	}
	
	adgw->lifetime = DEFAULT_PEER_LIFETIME;
	adgw->callback_function = adgw_expire;
	
	flush_scatter_peers();
	
	count = ( (hdr->length - OPTOIN_HEADER_SIZE - PEERS_INFO_OPT_SIZE) / PEERS_INFO_OPT_SIZE);
	while(count)
	{
		peer_opt = (Peers_info_opt *)pos;
		pos += PEERS_INFO_OPT_SIZE;

		// ο Ʈ ߰.
		peer = (struct peers_info_entry *)malloc(sizeof(struct peers_info_entry));
		memset(peer, 0, sizeof(struct peers_info_entry));

		strcpy(peer->dev_index, iface->dev_name);
		peer->mode = peer_opt->mode;
		peer->status = CONFIRMED_SCATTER_PEER;

		memcpy(&peer->ll_address, &peer_opt->ll_address, ADDRESS_INFO_SIZE);
		memcpy(&peer->s_address, &peer_opt->s_address, ADDRESS_INFO_SIZE);		
		memcpy(&peer->g_address, &peer_opt->g_address, ADDRESS_INFO_SIZE);				
		memcpy(&peer->nickname, &peer_opt->nickname, NICKNAME_INFO_SIZE);

		peer->lifetime = DEFAULT_PEER_LIFETIME;
		peer->callback_function = peer_expire;

		add_peers_entry(peer);

		printf("handle_scatter_peers_adv : NEW SCATTER PEER nick[%s]\n", peer->nickname.nick);
		debug_hexdump("Link-local address :  ", peer->ll_address.address, 16);
		debug_hexdump("Ad-hoc address :  ", peer->s_address.address, 16);	
		debug_hexdump("Global address :  ", peer->g_address.address, 16);	

		count--;
	}

	thread_rebuild_peer_list();

	printf("[handle_scatter_peers_adv] end\n");		
	return 0;
}



int send_dis_peers_req(struct interface_info_entry *iface, struct in6_addr *target)
{
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Dis_peers_msg		*msg;

	printf("[send_dis_peers_req] start\n");		

	if( config.mode != ADHOC_LINK_MODE )
	{
		printf("[send_dis_peers_req] Interface [%s] Current Mode is not ADHOC_LINK_MODE \n", iface->dev_name);
		return -1;
	}
	msg = (Dis_peers_msg *)pos;
	pos += DIS_PEERS_MSG_SIZE;

	/* Make Message  */
	msg->type = ICMPV6_AD_HOC;
	msg->code = 0; /*  code 뵵 reserved ̵ */
	msg->checksum = 0;
	msg->identifier = make_identifier();
	msg->reserved = 0; /* system socket ϱ  code reserved  */

	create_opt_header(pos, DISCOVER_PEERS_REQUEST, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	pos += OPTOIN_HEADER_SIZE;

	create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, NULL, &iface->nickname);
	pos += PEERS_INFO_OPT_SIZE;	

	if( target == NULL )
		ipv6_addr_all_nodes(&dst_addr);
	else
		memcpy(&dst_addr, target, sizeof(struct in6_addr));

	print_icmp_msg_info("SEND DISCOVER_PEERS_REQUEST", iface->dev_name, buf, pos-buf, &dst_addr);

	return send_icmpv6_msg(iface->socks.icmpv6_sock, buf, pos - buf, iface->ifindex, NULL, &dst_addr);
}




int send_dis_peers_res(struct interface_info_entry *iface, unsigned short id, struct peers_info_entry *peer)
{
	struct in6_addr		dst_addr;
	
	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos = buf;

	Nickname_info		nickname;

	printf("[send_dis_peers_res] start\n");	

	if( config.mode == ADHOC_DELAY_MODE )
	{
		printf("[send_dis_peers_res] Interface [%s] Current Mode is ADHOC_DELAY_MODE\n", iface->dev_name);
		return -1;
	}
	
	create_opt_header(pos, DISCOVER_PEERS_RESPONSE, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	pos += OPTOIN_HEADER_SIZE;

	if( config.mode == ADHOC_LINK_MODE )
		create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, NULL, &iface->nickname);
	else
		create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &iface->g_address, &iface->nickname);

	pos += PEERS_INFO_OPT_SIZE;

	memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));
	
	debug_hexdump("SEND DISCOVER_PEERS_RESPONSE", buf, pos-buf);
	
//	return send_udp_packet(iface->socks.udp_sock, config.udp_port, buf, pos-buf, &dst_addr);	
	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, pos-buf, iface->ifindex, NULL, &dst_addr);
}




int send_dis_adgw_adv(struct interface_info_entry *iface, struct in6_addr *target)
{
	struct in6_addr		dst_addr;
	
	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos = buf;

	Dis_peers_msg		*msg;
	Option_header		*hdr;

	printf("[send_dis_adgw_adv] start\n");		

	if( (config.mode < ADHOC_SCATTER_MODE) || (config.mode == ADHOC_DELAY_MODE) )
		return -1;	

 	// Make Message  
	msg = (Dis_peers_msg *)buf;
	pos+= DIS_PEERS_MSG_SIZE;
		
	msg->type = ICMPV6_AD_HOC;
	msg->code = 0; //  code 뵵 reserved ̵ 
	msg->checksum = 0;
	msg->identifier = make_identifier();
	msg->reserved = 0; // system socket ϱ  code reserved  
	
	hdr = (Option_header *)pos;
	create_opt_header(pos, ADVERTISEMENT_ADHOCGW, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	pos += OPTOIN_HEADER_SIZE;

	if(config.mode == ADHOC_PROXY_MODE )
		create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &iface->g_address, &iface->nickname);
	else
		create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &iface->g_address, &iface->nickname);

	pos += PEERS_INFO_OPT_SIZE;

	ipv6_addr_all_nodes(&dst_addr);

	print_icmp_msg_info("SEND ADVERTISEMENT_ADHOCGW", iface->dev_name, buf, pos-buf, &dst_addr);
	
	return send_icmpv6_msg(iface->socks.icmpv6_sock, buf, pos - buf, iface->ifindex, NULL, &dst_addr);
}



int send_adgw_join_req(struct interface_info_entry *iface, struct peers_info_entry *peer)
{
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Nickname_info		nickname;	
	Address_info			temp_addr;

	printf("[send_adgw_join_req] start\n");	

	if( (peer->mode == ADHOC_DELAY_MODE) || (peer->mode < ADHOC_SCATTER_MODE) )
	{
		printf("[send_adgw_join_req] Invaild peer mode [%s]\n", peer->nickname.nick);
		return -1;
	}

	create_opt_header(pos, ADGW_JOIN_REQUEST, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	pos += sizeof(Option_header);
	
	if(peer->mode == ADHOC_PROXY_MODE )
		make_proxy_address_conf(iface->dev_name, peer->g_address.address, 80, iface->mac, &temp_addr );
	else
		make_address_conf(iface->dev_name, peer->g_address.address, 64, iface->mac, &temp_addr );

	create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &temp_addr, &iface->nickname);
	pos += PEERS_INFO_OPT_SIZE;

	memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));			

	debug_hexdump("SEND ADGW_JOIN_REQUEST", buf, pos-buf);

	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, pos-buf, iface->ifindex, NULL, &dst_addr);
}



int send_adgw_join_res(struct interface_info_entry *iface, struct peers_info_entry *peer)
{
	int 					cnt=0;
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Option_header		*hdr;
	Nickname_info		nickname;	

	printf("[send_adgw_join_res] start\n");		

	create_opt_header(pos, ADGW_JOIN_RESPONSE, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	hdr = (Option_header *)pos;
	pos += OPTOIN_HEADER_SIZE;
	
	create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &iface->g_address, &iface->nickname);
	pos += PEERS_INFO_OPT_SIZE;

	if( !list_empty(&config.peers_list) )
	{
		struct list_head* lead = &config.peers_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)	
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( strcmp(entry->dev_index, iface->dev_name) )
			{
				if( (entry->status == CONFIRMED_SCATTER_PEER) )
				{
					printf("[send_adgw_join_res] Join peer[%s]\n", entry->nickname.nick);
					debug_hexdump("Scatter global address : ", entry->g_address.address, 16);
					create_peers_info_opt(pos, entry->mode , REACHABLE_SCATTER_SCOPE, iface->mac, &entry->ll_address, &entry->s_address, &entry->g_address, &entry->nickname);
					pos += PEERS_INFO_OPT_SIZE;
					cnt++;
				}
			}
		}	
	}

	hdr->length += (cnt * PEERS_INFO_OPT_SIZE);

	memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));			
	
	debug_hexdump("SEND ADGW_JOIN_RESPONSE", buf, pos-buf);

//	return send_udp_packet(iface->socks.udp_sock, config.udp_port, buf, pos-buf, &dst_addr);
	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, pos-buf, iface->ifindex, NULL, &dst_addr);
}



int send_scatter_peers_sol(struct interface_info_entry *iface, struct peers_info_entry *peer)
{
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Nickname_info		nickname;	
	Address_info			temp_addr;

	printf("[send_scatter_peers_sol] start\n");	

	if( (peer->mode == ADHOC_DELAY_MODE) || (peer->mode != ADHOC_SCATTER_MODE) )
	{
		printf("[send_scatter_peers_sol] Invaild peer mode [%s]\n", peer->nickname.nick);
		return -1;
	}
	else if( iface->scope != REACHABLE_SCATTER_SCOPE )
	{
		printf("[send_scatter_peers_sol] Invaild peer reachable status. [%s]\n", iface->dev_name);
		return -1;	
	}
	
	create_opt_header(pos, SCATTER_PEERS_SOL, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	pos += sizeof(Option_header);
	
	create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &iface->g_address, &iface->nickname);
	pos += PEERS_INFO_OPT_SIZE;

	memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));			

	debug_hexdump("SEND SCATTER_PEERS_SOL", buf, pos-buf);

	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, pos-buf, iface->ifindex, NULL, &dst_addr);
}

int send_scatter_peers_adv(struct interface_info_entry *iface, struct peers_info_entry *peer)
{
	int 					cnt=0;
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Option_header		*hdr;
	Nickname_info		nickname;	

	printf("[send_scatter_peers_adv] start\n");		

	if(peer != NULL)
	{
		if(peer->status != CONFIRMED_SCATTER_PEER)
		{
			printf("[send_scatter_peers_adv] Invaild peer [%s] status : Unconfirmed peer\n", peer->nickname.nick);
			return -1;
		}
	}

	create_opt_header(pos, SCATTER_PEERS_ADV, OPTOIN_HEADER_SIZE+PEERS_INFO_OPT_SIZE);
	hdr = (Option_header *)pos;
	pos += OPTOIN_HEADER_SIZE;
	
	create_peers_info_opt(pos, config.mode, REACHABLE_LINK_SCOPE, iface->mac, &iface->ll_address, &iface->s_address, &iface->g_address, &iface->nickname);
	pos += PEERS_INFO_OPT_SIZE;

	if( !list_empty(&config.peers_list) )
	{
		struct list_head* lead = &config.peers_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)	
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( strcmp(entry->dev_index, iface->dev_name) )
			{
				if( (entry->status == CONFIRMED_SCATTER_PEER) )
				{
					printf("[send_scatter_peers_adv] Join peer[%s]\n", entry->nickname.nick);
					debug_hexdump("Scatter global address : ", entry->g_address.address, 16);
					create_peers_info_opt(pos, entry->mode , REACHABLE_SCATTER_SCOPE, iface->mac, &entry->ll_address, &entry->s_address, &entry->g_address, &entry->nickname);
					pos += PEERS_INFO_OPT_SIZE;
					cnt++;
				}
			}
		}	
	}

	hdr->length += (cnt * PEERS_INFO_OPT_SIZE);

	if( peer == NULL )
		ipv6_addr_all_nodes(&dst_addr);
	else
		memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));
	
	debug_hexdump("SEND SCATTER_PEERS_ADV", buf, pos-buf);

	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, pos-buf, iface->ifindex, NULL, &dst_addr);
}


int send_conference_request(int type, struct interface_info_entry *iface, struct peers_info_entry *peer)
{
	int 					cnt=0;
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Option_header		*hdr;
	Nickname_info		nickname;	

	printf("[send_conference_request] start\n");		

	create_opt_header(pos, CONFERENCE_CONNECT_REQUEST, OPTOIN_HEADER_SIZE+CONFERENCE_INFO_OPT_SIZE);
	hdr = (Option_header *)pos;
	pos += OPTOIN_HEADER_SIZE;

	if(peer->status == CONFIRMED_SCATTER_PEER)
		create_conference_info_opt(pos, type, 0, &iface->g_address, &iface->nickname);
	else 
		create_conference_info_opt(pos, type, 0, &iface->s_address, &iface->nickname);
	
	pos += CONFERENCE_INFO_OPT_SIZE;	


	if( peer->status == CONFIRMED_SCATTER_PEER )
		memcpy(&dst_addr, peer->g_address.address, sizeof(struct in6_addr));
	else
		memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));										
		
	debug_hexdump("SEND CONFERENCE_CONNECT_REQUEST", buf, hdr->length);

	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, hdr->length, iface->ifindex, NULL, &dst_addr);
}


int send_conference_response(int type, int code, struct interface_info_entry *iface, struct peers_info_entry *peer)
{
	int 					cnt=0;
	struct in6_addr		dst_addr;

	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos=buf;

	Option_header		*hdr;
	Nickname_info		nickname;	

	printf("[send_conference_response] start\n");		

	create_opt_header(pos, CONFERENCE_CONNECT_RESPONSE, OPTOIN_HEADER_SIZE+CONFERENCE_INFO_OPT_SIZE);
	hdr = (Option_header *)pos;
	pos += OPTOIN_HEADER_SIZE;

	if(peer->status == CONFIRMED_SCATTER_PEER)
		create_conference_info_opt(pos, type, code, &iface->g_address, &iface->nickname);
	else 
		create_conference_info_opt(pos, type, code, &iface->s_address, &iface->nickname);
	
	pos += CONFERENCE_INFO_OPT_SIZE;	

	if( peer->status == CONFIRMED_SCATTER_PEER )
		memcpy(&dst_addr, peer->g_address.address, sizeof(struct in6_addr));
	else
		memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));										
		
	debug_hexdump("SEND CONFERENCE_CONNECT_REQUEST", buf, hdr->length);

	return send_udp_msg(iface->socks.udp_sock, config.udp_port, buf, hdr->length, iface->ifindex, NULL, &dst_addr);
}


int send_message(struct interface_info_entry *iface, char *message, struct peers_info_entry *peer)
{
	struct in6_addr		dst_addr;
	
	unsigned char			buf[MAX_MSG_LEN]={0x00,};
	unsigned char			*pos = buf;

	Option_header		*hdr;
	Nickname_info		nickname;
	Message_info_opt				*chat;

	printf("[send_message] start\n");		
	
	// Make Message  
	create_opt_header(pos, CHAT_MESSAGE, OPTOIN_HEADER_SIZE);
	hdr = (Option_header *)pos;
	pos += OPTOIN_HEADER_SIZE;

	memset(&nickname, 0, NICKNAME_INFO_SIZE);
	nickname.nicklen = strlen(iface->curr_wlan_info.nickname);
	strcpy(nickname.nick, iface->curr_wlan_info.nickname);
			
	create_chat_message_opt(pos, &nickname, message);
	pos += ( NICKNAME_INFO_SIZE + strlen(message) );

	hdr->length = pos-buf;
	
	if( peer->status == CONFIRMED_SCATTER_PEER )
		memcpy(&dst_addr, peer->g_address.address, sizeof(struct in6_addr));
	else
		memcpy(&dst_addr, peer->s_address.address, sizeof(struct in6_addr));				

	debug_hexdump("SEND CHAT_MESSAGE", buf, pos-buf);

	return send_udp_packet(config.chat_sock, config.chat_port, buf, pos-buf, &dst_addr);
}





void create_opt_header(unsigned char *msg, unsigned char type, int size)
{
	Option_header	*hdr = (Option_header *)msg;
	
	hdr->type = type;	
	hdr->length = size;				

	return ;
}


void create_peers_info_opt(unsigned char *msg, unsigned char mode, unsigned char scope, unsigned char *mac,  Address_info *ll_address, Address_info *s_address, Address_info *g_address, Nickname_info *nickname)
{
	Peers_info_opt	*opt = (Peers_info_opt *)msg;

	opt->mode = mode;
	opt->scope = scope;

	memcpy(&opt->mac_address, mac, MAC_INFO_SIZE);
	memcpy(&opt->ll_address, ll_address, ADDRESS_INFO_SIZE);
	memcpy(&opt->s_address, s_address, ADDRESS_INFO_SIZE);

	if(g_address != NULL)
		memcpy(&opt->g_address, g_address, ADDRESS_INFO_SIZE);
	
	memcpy(&opt->nickname, nickname, NICKNAME_INFO_SIZE);

	return ;
}

void create_conference_info_opt(unsigned char *msg, unsigned char type, unsigned char code, Address_info *g_address, Nickname_info *nickname)
{
	Conference_info_opt	*opt = (Conference_info_opt *)msg;

	opt->type = type;
	opt->code = code;

	memcpy(&opt->g_address, g_address, ADDRESS_INFO_SIZE);
	memcpy(&opt->nickname, nickname, NICKNAME_INFO_SIZE);

	return ;
}


void create_chat_message_opt(unsigned char *msg, Nickname_info *nickname, char *message)
{
	Message_info_opt	*opt = (Message_info_opt *)msg;

	memcpy(&opt->nickname, nickname, NICKNAME_INFO_SIZE);
	strcpy(opt->msg, message);

	return ;
}





void add_interface_entry(struct interface_info_entry *iface)
{
	printf("Add interface entry[%s]\n", iface->dev_name);
	list_add_tail(&iface->list, &config.devices);
}

void	add_peers_entry(struct peers_info_entry *peer)
{
	list_add(&peer->list, &config.peers_list);
}

void	add_adgw_entry(struct peers_info_entry *peer)
{
	list_add(&peer->list, &config.adgws_list);
}

void	del_list_entry(struct list_head *entry)
{
	list_del_init(entry);
	free(entry);
}








struct interface_info_entry *search_interface_by_lladdress(char *lladdr)
{
	if( !list_empty(&config.devices) )
	{
		struct list_head* lead = &config.devices;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)
		{	
			struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);

//			debug_hexdump("search_interface_by_lladdress: Key entry " , lladdr, 16);
//			debug_hexdump("search_interface_by_lladdress: List entry " , entry->ll_address.address, 16);
			
			//  ϴ Ʈ ã´. update ų   ִ.
			if(memcmp( entry->ll_address.address, lladdr, sizeof(struct in6_addr)))
				continue;
			else
			{
				debug_hexdump("search_interface_by_lladdress : Found entry " , entry->ll_address.address, 16);
				return entry;		
			}
		}
	}

	return NULL;
}




struct interface_info_entry *search_interface_by_name(char *name)
{
	if( !list_empty(&config.devices) )
	{
		struct list_head* lead = &config.devices;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)		
		{
			struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( !strcmp(name, entry->dev_name) )
			{
				printf("[search_interface_by_name] found interface [%s]\n", entry->dev_name);
				return entry;
			}

		}	
	}
	printf("[search_interface_by_name] Not found interface [%s]\n", name);
	return NULL;
}

struct ap_entry *search_infra_by_essid(char *essid)
{
	if( !list_empty( &config.infra_network_list) )
	{
		struct list_head* lead = &config.infra_network_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct ap_entry *entry = list_entry(p, typeof(*entry), list);
			
			if( !memcmp( entry->essid, essid, strlen(essid)) )
				return entry;
		}	
	}

	return NULL;
}



struct ap_entry *search_adhoc_by_essid(char *essid)
{
	if( !list_empty( &config.adhoc_network_list) )
	{
		struct list_head* lead = &config.adhoc_network_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct ap_entry *entry = list_entry(p, typeof(*entry), list);
			
			if( !memcmp( entry->essid, essid, strlen(essid)) )
				return entry;
		}	
	}

	return NULL;
}


struct peers_info_entry *search_adgw_by_lladdress(char *lladdr)
{
	if( !list_empty(&config.adgws_list) )
	{
		struct list_head* lead = &config.adgws_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)
		{	
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

//			debug_hexdump("search_adgw_by_lladdress: Key entry " , lladdr, 16);
//			debug_hexdump("search_adgw_by_lladdress: List entry " , entry->ll_address.address, 16);
			
			//  ϴ Ʈ ã´. update ų   ִ.
			if(memcmp( entry->ll_address.address, lladdr, sizeof(struct in6_addr)))
				continue;
			else
			{
				debug_hexdump("search_adgw_by_lladdress : Found entry " , entry->ll_address.address, 16);
				return entry;		
			}
		}
	}

	return NULL;
}



struct peers_info_entry *search_adgw_by_nick(char *nickname)
{
	if( !list_empty(&config.adgws_list) )
	{
		struct list_head* lead = &config.adgws_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

//			printf("search_adgw_by_nick: Key entry [%s]" , nickname);
	//		printf("search_adgw_by_nick: List  entry [%s]" , entry->nickname.nick);
			
			if( strcmp(entry->nickname.nick, nickname) )
				continue;
			else
			{
				printf("search_adgw_by_nick : Found ADGW [%s]\n", entry->nickname.nick);
				return entry;
			}
		}	
	}

	return NULL;
}



struct peers_info_entry *search_peer_by_lladdress(char *lladdr)
{
	if( !list_empty(&config.peers_list) )
	{
		struct list_head* lead = &config.peers_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)
		{	
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

//			debug_hexdump("search_peer_by_lladdress: Key entry " , lladdr, 16);
//			debug_hexdump("search_peer_by_lladdress: List entry " , entry->ll_address.address, 16);
			
			//  ϴ Ʈ ã´. update ų   ִ.
			if(memcmp( entry->ll_address.address, lladdr, sizeof(struct in6_addr)))
				continue;
			else
			{
				debug_hexdump("search_peer_by_lladdress : Found entry " , entry->ll_address.address, 16);
				return entry;		
			}
		}
	}

	return NULL;
}

struct peers_info_entry *search_peer_by_nick(char *nickname)
{
	if( !list_empty( &config.peers_list ) )
	{
		struct list_head* lead = &config.peers_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

//			printf("search_peer_by_nick: Key entry [%s]" , nickname);
//			printf("search_peer_by_nick: List  entry [%s]" , entry->nickname.nick);
			
			if( strcmp(entry->nickname.nick, nickname) )
				continue;
			else
			{
				printf("search_peer_by_nick : Found Peer [%s]\n", entry->nickname.nick);
				return entry;
			}
		}	
	}
	return NULL;
}





void expire_entry_time_handle()
{
	if( !list_empty( &config.peers_list ) )
	{
		struct list_head* lead = &config.peers_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( entry->lifetime )
				entry->lifetime--;	
			else
				entry->callback_function(entry);
		}	
	}	
	if( !list_empty( &config.adgws_list ) )
	{
		struct list_head* lead = &config.adgws_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( entry->lifetime )
				entry->lifetime--;	
			else
				entry->callback_function(entry);
		}	
	}	
}

void flush_scatter_peers()
{
	if( !list_empty( &config.peers_list ) )
	{
		struct list_head* lead = &config.peers_list;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)			
		{
			struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( entry->status == CONFIRMED_SCATTER_PEER )
				del_list_entry((struct list_head *)entry);
		}	
	}	
}

void adgw_expire(struct peers_info_entry *adgw)
{
	printf("[adgw_expire] ADGW(mode:%d) nickname [%s]\n", adgw->mode, adgw->nickname.nick);
	debug_hexdump("Link-local address : ", adgw->ll_address.address, 16);
	debug_hexdump("Global address : ", adgw->g_address.address, 16);

	if(config.curr_adhoc_gw == adgw)
	{
		char buf[128]={0x00,};
		struct interface_info_entry *iface;
		
		printf("[adgw_expire] Warning! Expire Current Ad-hoc gateway\n");
		sprintf(buf,  "Expire Current Ad-hoc gateway [%s]\n", adgw->nickname.nick);
		thread_popup_info(buf);

		if( (iface = search_interface_by_name(adgw->dev_index)) == NULL)
			printf("[adgw_expire] Not found interface [%s]\n", adgw->dev_index);
		else
		{
			iface->scope = ADHOC_LINK_MODE;
			default_router_del(iface->dev_name, NULL);
			addr_del(iface->dev_name, (struct in6_addr *)iface->g_address.address, iface->g_address.prefixlen);
			memset(&iface->g_address, 0, ADDRESS_INFO_SIZE);
	}
		flush_scatter_peers();
	}
		
	del_list_entry((struct list_head *)adgw);
	thread_rebuild_peer_list();
}


void peer_expire(struct peers_info_entry *peer)
{
	printf("[peer_expire] Peer nickname [%s]\n", peer->nickname.nick);
	debug_hexdump("Link-local address : ", peer->ll_address.address, 16);

	if( peer->status == CONFIRMED_SCATTER_PEER )
	{
		struct interface_info_entry *iface;
		
		if( (iface = search_interface_by_name(peer->dev_index)) == NULL )
			printf("[peer_expire] Not found peer[%s] incomming interface.\n", peer->nickname.nick);
		else
		{
			del_list_entry((struct list_head *)peer);
			thread_rebuild_peer_list();
		}
	}
}


void time_handle(struct timeval *callback_time, struct timeval *tv)
{
	struct timeval now;
	unsigned long diff =0;
	
	tv->tv_sec = 0;
	tv->tv_usec = 0;
	
	gettimeofday(&now, NULL);
	if( cmp_timeval(callback_time, &now) < 0 )
	{
		memcpy(callback_time, &now, sizeof(struct timeval));
		add_usecs(callback_time, (config.wait_time*1000000));
	}
	diff = ((callback_time->tv_sec - now.tv_sec) *1000000) + ( callback_time->tv_usec -now.tv_usec);

	add_usecs(tv, diff);
}




/* returns 1, 0, -1 when tv1 is greater, equal or less than tv2 */
int cmp_timeval(struct timeval *tv1, struct timeval *tv2)
{
	if (tv1->tv_sec < tv2->tv_sec) return -1;
	if (tv1->tv_sec > tv2->tv_sec) return 1;
	if (tv1->tv_usec < tv2->tv_usec) return -1;
	if (tv1->tv_usec > tv2->tv_usec) return 1;
	return 0;
}

void add_usecs(struct timeval *tv, unsigned int usecs)
{
	tv->tv_usec +=(long int) usecs;
	tv->tv_sec += tv->tv_usec / 1000000;
	tv->tv_usec = tv->tv_usec % 1000000;
}



/* identifier Ѵ */
unsigned short make_identifier()
{
	static unsigned short identifier;

	identifier++;
	if(identifier >= 65535)
		identifier=1;		

	return identifier;
}



void adhoc_advertisement(void)
{
	if( config.mode == ADHOC_DELAY_MODE)
		return ;
	
	if( config.mode == ADHOC_LINK_MODE )
	{
		if( !list_empty(&config.devices) )
		{
			struct list_head* lead = &config.devices;
			struct list_head *p,*n;

			list_for_each_safe(p, n, lead)		
			{
				struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);

				if( (entry->ifmode == WIRELESS_INTERFACE) && (entry->curr_wlan_info.mode == IW_MODE_ADHOC) )
				{
					if( entry->scope == REACHABLE_SCATTER_SCOPE)
						send_scatter_peers_sol(entry, config.curr_adhoc_gw);
					send_dis_peers_req(entry, NULL);
				}
			}
		}	
		return ;
	}
	else if( config.mode == ADHOC_PROXY_MODE )
	{
		if( !list_empty(&config.peers_list) )
		{
			struct list_head* lead = &config.peers_list;
			struct list_head *p,*n;

			list_for_each_safe(p, n, lead)		
			{
				struct peers_info_entry *entry = list_entry(p, typeof(*entry), list);

				if( entry->status == CONFIRMED_SCATTER_PEER );
					send_ndisc_na(config.proxy_if->socks.icmpv6_sock, config.proxy_if->ifindex, config.proxy_if->mac, (struct in6_addr*)entry->g_address.address, FALSE);
			}
		}	
	}

	if( !list_empty(&config.devices) )
	{
		struct list_head* lead = &config.devices;
		struct list_head *p,*n;

		list_for_each_safe(p, n, lead)		
		{
			struct interface_info_entry *entry = list_entry(p, typeof(*entry), list);

			if( (entry->ifmode == WIRELESS_INTERFACE) && (entry->curr_wlan_info.mode == IW_MODE_ADHOC) )
				if( entry->proxy_enable == ADHOC_PROXY_DISABLE )
					send_dis_adgw_adv(entry, NULL);
		}
	}
}



int run_skt_conference_vic(struct in6_addr *addr, int port)
{
	char s_buf[512]={0x00,}, ip_buf[128]={0x00,};

	if( fork() == 0 )
	{
		inet_ntop(AF_INET6, addr, ip_buf, 128);
		sprintf(s_buf, "vic %s/%d", ip_buf, port);

		printf("[run_skt_conference_vic] Starting [%s]\n", s_buf);
		system(s_buf);

		exit(0);
	}	
	return 0;
}


int run_skt_conference_rat(struct in6_addr *addr, int port)
{
	char s_buf[512]={0x00,}, ip_buf[128]={0x00,};

	if( fork() == 0 )
	{
		inet_ntop(AF_INET6, addr, ip_buf, 128);
		sprintf(s_buf, "rat %s/%d", ip_buf, port);

		printf("[run_skt_conference_rat] Starting [%s]\n", s_buf);
		system(s_buf);

		exit(0);
	}	
	return 0;
}


int print_icmp_msg_info(char *title, char *dev, unsigned char *msg, int len, struct in6_addr *addr)
{
	Dis_peers_msg *icmp;
	Option_header *hdr;
	Peers_info_opt *info;
	char addr_b[128] = {0x00,};

	icmp = (Dis_peers_msg *)msg;
	hdr = (Option_header *)(msg+sizeof(Dis_peers_msg));
	info = (Peers_info_opt *)(msg+sizeof(Dis_peers_msg)+sizeof(Option_header));

	printf(" ------------ %s ------------\n", title);
	inet_ntop(AF_INET6, addr, addr_b, 128);
	printf(" device index %s, ipv6 addr %s, size %d\n", dev, addr_b, len);
	debug_hexdump(" icmp : ", (unsigned char *)icmp, sizeof(Dis_peers_msg));
	debug_hexdump(" hdr   : ", (unsigned char *)hdr, sizeof(Option_header));	
	debug_hexdump(" info  : ", (unsigned char *)hdr, sizeof(Peers_info_opt));
	printf("----------------------------------------------\n");

	return 0;
}

