#include <asm/types.h>
#include <linux/if_ether.h>

//rad//////
#include <config.h>

#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <time.h>
#include <syslog.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <netdb.h>
#include <pwd.h>
#include <grp.h>

#include <sys/types.h>
#ifdef HAVE_INTTYPES_H
# include <inttypes.h>
#endif

#ifdef HAVE_SYS_PARAM_H
# include <sys/param.h>
#else
# ifdef HAVE_MACHINE_PARAM_H
#  include <machine/param.h>
# endif
# ifdef HAVE_MACHINE_LIMITS_H
#  include <machine/limits.h>
# endif
#endif

#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/uio.h>

#include <sys/stat.h>
#include <fcntl.h>

#include <netinet/in.h>

#include <netinet/ip6.h>
#include <netinet/icmp6.h>

#include <arpa/inet.h>

#include <sys/sysctl.h>


#ifdef HAVE_NET_IF_DL_H
# include <net/if_dl.h>
#endif
#ifdef HAVE_NET_IF_TYPES_H
# include <net/if_types.h>
#endif
#if defined(HAVE_NET_IF_ARP_H) && !defined(ARPHRD_ETHER)
# include <net/if_arp.h>
#endif /* defined(HAVE_NET_IF_ARP_H) && !defined(ARPHRD_ETHER) */

#ifdef HAVE_SYS_SOCKIO_H
# include <sys/sockio.h>
#endif

#ifdef HAVE_GETOPT_H
# include <getopt.h>
#endif


#define MSG_SIZE			4096


/* Router Configuration Variables: */

/* For each multicast interface: */

/* #define DFLT_AdvSendAdv		not used, always read from config */
#define DFLT_MaxRtrAdvInterval		600
#define DFLT_MinRtrAdvInterval(iface)	((int)(0.33 * (double)(iface)->MaxRtrAdvInterval))
#define DFLT_AdvManagedFlag		0
#define DFLT_AdvOtherConfigFlag		0
#define DFLT_AdvLinkMTU			0
#define DFLT_AdvReachableTime		0
#define DFLT_AdvRetransTimer		0
#define DFLT_AdvCurHopLimit		64	/* as per RFC 1700 or the 
						   next incarnation of it :) */
#define	DFLT_AdvDefaultLifetime(iface)	(3 * (iface)->MaxRtrAdvInterval)

/* Options sent with RA */

#define DFLT_AdvSourceLLAddress		1

/* Each prefix has an associated: */

#define DFLT_AdvValidLifetime		2592000 /* seconds */
#define DFLT_AdvOnLinkFlag		1
#define DFLT_AdvPreferredLifetime	604800 /* seconds */
#define DFLT_AdvAutonomousFlag		1


/* Protocol (RFC2461) constants: */

/* Router constants: */

#define MAX_INITIAL_RTR_ADVERT_INTERVAL	16
#define MAX_INITIAL_RTR_ADVERTISEMENTS	3
#define MAX_FINAL_RTR_ADVERTISEMENTS	3
#define MIN_DELAY_BETWEEN_RAS		3
#define MAX_RA_DELAY_TIME		(1000.0/2.0) /* milliseconds */

/* Host constants: */

#define MAX_RTR_SOLICITATION_DELAY	1
#define RTR_SOLICITATION_INTERVAL	4
#define MAX_RTR_SOLICITATIONS		3

/* Node constants: */

#define MAX_MULTICAST_SOLICIT		3
#define MAX_UNICAST_SOLICIT		3
#define MAX_ANYCAST_DELAY_TIME		1
#define MAX_NEIGHBOR_ADVERTISEMENT	3
#define REACHABLE_TIME			30000 /* milliseconds */
#define RETRANS_TIMER			1000 /* milliseconds */
#define DELAY_FIRST_PROBE_TIME		5
#define MIN_RANDOM_FACTOR		(1.0/2.0)
#define MAX_RANDOM_FACTOR		(3.0/2.0)

/* MAX and MIN (RFC2461), Mobile IPv6 extensions will override if in use */

#define MIN_MaxRtrAdvInterval		4
#define MAX_MaxRtrAdvInterval		1800

#define MIN_MinRtrAdvInterval		3
#define MAX_MinRtrAdvInterval(iface)	((int)(0.75 * (double)(iface)->MaxRtrAdvInterval))

#define MIN_AdvDefaultLifetime(iface)	((iface)->MaxRtrAdvInterval)
#define MAX_AdvDefaultLifetime		9000

#define	MIN_AdvLinkMTU			576

#define MAX_AdvReachableTime		3600000 /* 1 hour in milliseconds */

#define MAX_AdvCurHopLimit		255

#define MAX_PrefixLen			128

/*
 * Mobile IPv6 extensions, off by default
 */

#define DFLT_AdvRouterAddr		0
#define DFLT_AdvHomeAgentFlag		0
#define DFLT_AdvIntervalOpt		0
#define DFLT_AdvHomeAgentInfo		0

/* Option types (defined also at least in glibc 2.2's netinet/icmp6.h) */

#ifndef ND_OPT_RTR_ADV_INTERVAL
#define ND_OPT_RTR_ADV_INTERVAL         7
#endif
#ifndef ND_OPT_HOME_AGENT_INFO
#define ND_OPT_HOME_AGENT_INFO          8
#endif

/* Flags */

#ifndef ND_RA_FLAG_HOME_AGENT
#define ND_RA_FLAG_HOME_AGENT		0x20
#endif
#ifndef ND_OPT_PI_FLAG_RADDR
#define ND_OPT_PI_FLAG_RADDR		0x20
#endif

/* Configurable values */

#define DFLT_HomeAgentPreference	0
#define DFLT_HomeAgentLifetime(iface)	DFLT_AdvDefaultLifetime(iface)

/* Other */

#define AdvertisementInterval(iface)	((iface)->MaxRtrAdvInterval))

#define MIN_MinRtrAdvInterval_MIPv6	(1.0/2.0)
#define MIN_MaxRtrAdvInterval_MIPv6	(3.0/2.0)
#define RTR_SOLICITATION_INTERVAL_MIPv6	1 /* Recommended value by MIPv6 */

#define MIN_HomeAgentLifetime		1 /* 0 must NOT be used */
#define MAX_HomeAgentLifetime		65520 /* 18.2 hours in secs */

/* #define MAX_RTR_SOLICITATIONS This MAY be ignored by MIPv6 */


typedef struct {
	unsigned char           ether_dhost[ETH_ALEN];
	unsigned char           ether_shost[ETH_ALEN];
	unsigned short          length;
} __attribute__((packed)) etherHdr;



typedef struct
{
	__u8 family;
	__u8 bytelen;
	__s16 bitlen;
	__u32 data[4];
} inet_prefix;


#define DEFAULT_GW_ADDRESS "2000::0"

#define DEFAULT_UDP_PORT	5677
#define DEFAULT_VIC_PORT	5777
#define DEFAULT_RAT_PORT	5778

#define PUBLIC_RADV_WAIT_TIME	5

#ifndef ETH_ALEN
#define ETH_ALEN	6		/* Octets in one ethernet addr	 */
#endif

#ifndef IP6_RT_PRIO_ADDRCONF
#define IP6_RT_PRIO_ADDRCONF	256
#endif

#ifndef ND_OPT_PI_FLAG_RADDR
#define ND_OPT_PI_FLAG_RADDR		0x20
#endif




//

int neigh_del(char *dev, struct in6_addr *addr);
int neigh_add(char *dev, struct in6_addr *addr, char *lladdr);
int neigh_add_proxy(char *dev, struct in6_addr *addr);
int neigh_del_proxy(char *dev, struct in6_addr *addr);
int ip6_neigh_modify(int cmd, int flags, int type, struct in6_addr *target_addr, char *target_link_addr, char *device);
void ipv6_addr_all_nodes(struct in6_addr *addr);
void ipv6_addr_all_routers(struct in6_addr *addr);
int addr_del(char *dev, struct in6_addr *addr, int prefix_len);
int addr_add(char *dev, struct in6_addr *addr, int prefix_len);
int ip6_addr_del(int cmd, struct in6_addr *addr, int prefix_len, char *device);
int ip6_addr_add(int cmd, struct in6_addr *addr, int prefix_len, char *device);
int default_router_add(char *dev, struct in6_addr *addr);
int get_default_route_info(char * tgt_dev, struct in6_addr *gw_addr);
int default_router_del(char *dev, struct in6_addr *addr);
int ip6_route_modify(int cmd, unsigned flags, int type, int reverse, struct in6_addr *prefix, int prefix_len, int table, char *device, int priority , struct in6_addr *gateway,  int gw_len );
void get_mac_addr(unsigned char *mac, char *if_name);
int send_icmpv6_msg(int sock, char *msg, int len, int ifindex, struct in6_addr *src_addr, struct in6_addr *dest);
int open_icmpv6_socket(void);
int send_udp_packet(int sock, unsigned short port, char *msg, int len, struct in6_addr *addr);
int open_udpsock6(unsigned short port, struct in6_addr *addr);
int get_ipv6_addr(unsigned char *device, int scope,  struct in6_addr *addr, unsigned int *ifindex);
void init_scatter_autoconf();
int init_global_address(unsigned char *device);
int prefix_compare(struct in6_addr *addr, struct in6_addr *prefix, unsigned int nprefix);
int change_autoconf_status(char *dev, char *status);
int change_forwarding_status(char *status);
int ifup_ipv6_restart(char *dev);
void send_ra(int sock, int ifindex, struct in6_addr *dest, struct in6_addr *prefix, int plen, unsigned char * lladdr);
void send_ndisc_na(int sockfd, int ifindex, char *dev_mac, struct in6_addr *target_addr , int is_router ) ;
int send_udp_msg(int sock, unsigned short port, char *msg, int len, int ifindex, struct in6_addr *src_addr, struct in6_addr *dest);
void send_ndisc_rs(int sockfd, int ifindex, char *dev_mac);
