#ifndef _SCAN_H
#define _SCAN_H

#include "iwlib.h"		/* Header */
#include "list.h"
#include "debug.h"

#define	MAX_MODE_LEN	16
#define	MAX_INTERFACE_NUM	2


struct ap_entry
{
	struct list_head			list;
	int						id;
	int						strength;
	int						channel;
	unsigned char				ap_link_addr[6];
	int						mode_t;
	unsigned char				mode[MAX_MODE_LEN+1];	
	unsigned char				essid[IW_ESSID_MAX_SIZE+1];
	unsigned char				nickname[IW_ESSID_MAX_SIZE+1];
	unsigned char				device[IFNAMSIZ+1];
};

struct wlan_info
{
	int		mode;								/* Operation mode */
	int		channel;								/* Frequency/channel */
	char		essid[IW_ESSID_MAX_SIZE + 1];		/* ESSID (extended network) */
	char		nickname[IW_ESSID_MAX_SIZE + 1]; 	/* NickName */
};

void wireless_commit(int sock, char *dev);
int scanning(int mode, int scan_sock, struct list_head *ap_list, char *ifname);
int ap_link_change(int scan_sock, int mode, char* apessid, int channel, char *nick, char *ifname);
int get_curr_wireless_info(int skfd, char *ifname, struct wlan_info *info);
int free_ap_list(struct list_head *ap_list);

#endif
